﻿#include "MQPlugin.h"
#include "MQBasePlugin.h"

class ObjectListReorder : public MQStationPlugin
{
public:
	friend ObjectListReorderWindow;

	ObjectListReorder();
	virtual ~ObjectListReorder();

	// プラグインIDを返す。
	virtual void GetPlugInID(DWORD *Product, DWORD *ID);
	// プラグイン名を返す。
	virtual const char *GetPlugInName(void);
	// ポップアップメニューに表示される文字列を返す。
	virtual const char *EnumString(void);

	// アプリケーションの初期化
	virtual BOOL Initialize();
	// アプリケーションの終了
	virtual void Exit();

	// 表示・非表示切り替え要求
	virtual BOOL Activate(MQDocument doc, BOOL flag);
	// 表示・非表示状態の返答
	virtual BOOL IsActivated(MQDocument doc);

//	virtual void OnUpdateObjectList(MQDocument doc);

	typedef bool (ObjectListReorder::*ExecuteCallbackProc)(MQDocument doc);

	void Execute(ExecuteCallbackProc proc);

	BOOL insert(MQDocument doc);
	BOOL up(MQDocument doc);
	BOOL down(MQDocument doc);
	BOOL top(MQDocument doc);
	BOOL bottom(MQDocument doc);
	BOOL gather(MQDocument doc);

protected:
	struct CallbackInfo {
		ExecuteCallbackProc proc;
	};

	// コールバックに対する実装部
	virtual bool ExecuteCallback(MQDocument doc, void *option);

private:
	ObjectListReorderWindow *m_Window;
	MQDocument m_doc;

	int moveobj(MQDocument doc, MQObject &target, MQObject to);
	int movechildren(MQDocument doc, std::vector<std::pair<MQObject, int>> childlist, MQObject target, int depthdiff);
	MQObject next(MQDocument doc, int index, bool forward);
	bool isFolding(MQDocument doc, MQObject obj);
	MQObject search_next(MQDocument doc, MQObject target, bool forward, bool skipfolding);
	std::vector<std::pair<MQObject, int>> getChildList(MQDocument doc, MQObject obj);

	bool m_bActivate;
};

