#include <windows.h>

#include "ObjectListReorderWindow.h"
#include "ObjectListReorder.h"

ObjectListReorderWindow::ObjectListReorderWindow(ObjectListReorder *plugin, MQWindowBase& parent) : MQWindow(parent), m_pPlugin(plugin)
{
	SetTitle(L"ObjectListReorder");
//	SetInSpace(0);
//	SetOutSpace(0);

	MQFrame *frame1 = CreateVerticalFrame(this);
	frame1->SetInSpace(0);
	frame1->SetOutSpace(0.2);

	MQButton *m_button1 = CreateButton(frame1);
	m_button1->SetText(L"insert (&H)ere\nfrom bottom");
	m_button1->AddClickEvent(this, &ObjectListReorderWindow::insert);

	MQButton *m_button2 = CreateButton(frame1);
	m_button2->SetText(L"up(&U)");
	m_button2->AddClickEvent(this, &ObjectListReorderWindow::up);

	MQButton *m_button3 = CreateButton(frame1);
	m_button3->SetText(L"down(&D)");
	m_button3->AddClickEvent(this, &ObjectListReorderWindow::down);

	MQButton *m_button4 = CreateButton(frame1);
	m_button4->SetText(L"top(&T)");
	m_button4->AddClickEvent(this, &ObjectListReorderWindow::top);

	MQButton *m_button5 = CreateButton(frame1);
	m_button5->SetText(L"bottom(&B)");
	m_button5->AddClickEvent(this, &ObjectListReorderWindow::bottom);

	MQButton *m_button6 = CreateButton(frame1);
	m_button6->SetText(L"gather(&G)");
	m_button6->AddClickEvent(this, &ObjectListReorderWindow::gather);

	AddHideEvent(this, &ObjectListReorderWindow::OnHide);
	count = 0;

	AddKeyDownEvent(this, &ObjectListReorderWindow::keyevent);
}

ObjectListReorderWindow::~ObjectListReorderWindow()
{
	obj_.deleteThis();
}

BOOL ObjectListReorderWindow::insert(MQWidgetBase *sender, MQDocument doc)
{
	return m_pPlugin->insert(doc);
}

BOOL ObjectListReorderWindow::up(MQWidgetBase *sender, MQDocument doc)
{
	return m_pPlugin->up(doc);
}

BOOL ObjectListReorderWindow::down(MQWidgetBase *sender, MQDocument doc)
{
	return m_pPlugin->down(doc);
}

BOOL ObjectListReorderWindow::top(MQWidgetBase *sender, MQDocument doc)
{
	return m_pPlugin->top(doc);
}

BOOL ObjectListReorderWindow::bottom(MQWidgetBase *sender, MQDocument doc)
{
	return m_pPlugin->bottom(doc);
}

BOOL ObjectListReorderWindow::gather(MQWidgetBase *sender, MQDocument doc)
{
	return m_pPlugin->gather(doc);
}

BOOL ObjectListReorderWindow::OnHide(MQWidgetBase *sender, MQDocument doc)
{
	if(m_pPlugin->m_bActivate){
		m_pPlugin->m_bActivate = false;
		m_pPlugin->WindowClose();
	}
	return FALSE;
}

BOOL ObjectListReorderWindow::keyevent(MQWidgetBase *sender, MQDocument doc, MQWidgetKeyParam& param)
{
	if(param.Alt) {
		switch(param.Key) {
		case 0x48: return insert(sender, doc); break;
		case 0x55: return up(sender, doc); break;
		case 0x44: return down(sender, doc); break;
		case 0x54: return top(sender, doc); break;
		case 0x42: return bottom(sender, doc); break;
		case 0x47: return gather(sender, doc); break;
		}
	}
	return FALSE;
}
